#include "JsprintfObj.h"
#include "JInteger.h"
#include "JIntegerData.h"
#include "JStringData.h"
#include "JIntegerProperty.h"
#include "JIntegerListProperty.h"
#include "JStringProperty.h"
#include "JLinkObj.h"
#include "JBytesData.h"


char* theJsprintfObj = JsprintfObj().Register();


const char* JsprintfObj::className() const { return "JsprintfObj";}


JObject* JsprintfObj::clone() const { return new JsprintfObj(*this);}


// class constructor
JsprintfObj::JsprintfObj() {
  igm = 1;
  ogm = 1;
}


void JsprintfObj::draw(JGraphics g, int x, int y, int w, int h) {
  JRect rect(x, y, w, h);
  drawText(g, JString("sprintf"), rect);
}


boolean JsprintfObj::inputAllowed(int n)
{ return !inputSet(n).last();}
JString JsprintfObj::inputTag(int n) {
  char* tag[] = {
    "inString" };
  return( tag[n] );
}


int JsprintfObj::outputType( int n ) {
  if ( n == 0 ) return JStringData::id;
  return JIntegerData::id;
}
int JsprintfObj::inputType( int n ) {
  if ( n == 0 ) return JStringData::id;
  return JIntegerData::id;
}
JString JsprintfObj::outputTag(int n) {
  char* tag[] = {
    "outString" };
  return( tag[n] );
}


JFRect JsprintfObj::inputArea(int n) {
  //if ( n < ( 1 )) {
    return leftArea( n, 0, 1, 0.1, 0.8 );
 // }//
}


JFRect JsprintfObj::outputArea(int n) {
  return rightArea(n, 0, 1);
}


int JsprintfObj::inputFace(int n) {
  if ( n < 1 ) {
    return LEFT;
  } else {
    return TOP;
  }
}


int JsprintfObj::outputFace(int n) {
  return RIGHT;
}


JFPoint JsprintfObj::inputPoint(int n, JLinkObj& link) {
  return leftPoint( n, link, 0, 1, 0.1, 0.8);
}


JFPoint JsprintfObj::outputPoint(int n, JLinkObj& link) {
  return rightPoint(n, link, 0, 1);
}


void JsprintfObj::access(int n, JLinkObj& link, const JDataType& data) {
  if ( n == 0 ) {
    JSTRING(data) = outString;
  }
}

#include <stdio.h>
static char buf[100];
void JsprintfObj::engine(int n, JLinkObj& link) {
  switch (n) {
  case INSTRING:
    link.access( JStringData( inString ));
	//char buf[100];
	sprintf( buf, "%s\n", (char*)inString );
	if ( buf[0] == '^' ) {
		buf[0] = buf[1] - 'a' + 1;
		buf[1] = '\n';
		buf[2] = 0;
	}
	outString = JString( buf );
	//JComponent::debug( outString );
	//JComponent::debug( "xxx\n" );
	broadcast( 0 );
    break;
  default:
    break;
  }
}


